package haskell.data;
import java.util.*;

public class UTuple2<T1> extends Tuple2<T1,T1>
                         implements Iterable<T1>{
  public UTuple2(T1 e1,T1 e2){
    super(e1,e2);
  }

  public Iterator<T1> iterator(){
    return new Iterator<T1>(){
      int i=0;
      public boolean hasNext(){
        return i<2;
      }
      public T1 next(){
        i++;
        return i==1?e1:e2;
      }
    };
  }
}
