package haskell.data.functions;

public interface Function1<T1,R> {
  R eval(T1 a1);

  <R2> Function1<T1,R2> compose(final Function1<R,R2> f2) default{
    return new Function1<T1,R2>(){
      public R2 eval(T1 a1){return f2.eval(Function1.this.eval(a1));} 
    };
  }

}
